#include <QApplication>
#include <QQmlApplicationEngine>
#include <QSettings>
#include <QQmlContext>
#include <QQuickStyle>
#include "settinginterface.h"
#include "plcman.h"
#include "datasource.h"
int main(int argc, char *argv[])
{
    QApplication::setAttribute(Qt::AA_EnableHighDpiScaling);
    QApplication app(argc, argv);

    QQuickStyle::setStyle("Material");

    SettingInterface setting;
    PlcMan plc;
    plc.setOption(&setting);

    DataSource dataSource(NULL);
    dataSource.setPlc(&plc);
    QQmlApplicationEngine engine;
    engine.rootContext()->setContextProperty( "exset", &setting);
    engine.rootContext()->setContextProperty( "explc", &plc);
    engine.rootContext()->setContextProperty("dataSource", &dataSource);
    engine.load(QUrl(QStringLiteral("qrc:/main.qml")));
    if (engine.rootObjects().isEmpty())
        return -1;

    return app.exec();
}
