/****************************************************************************
**
** Copyright (C) 2017 The Qt Company Ltd.
** Contact: https://www.qt.io/licensing/
**
** This file is part of the examples of the Qt Toolkit.
**
** $QT_BEGIN_LICENSE:BSD$
** Commercial License Usage
** Licensees holding valid commercial Qt licenses may use this file in
** accordance with the commercial license agreement provided with the
** Software or, alternatively, in accordance with the terms contained in
** a written agreement between you and The Qt Company. For licensing terms
** and conditions see https://www.qt.io/terms-conditions. For further
** information use the contact form at https://www.qt.io/contact-us.
**
** BSD License Usage
** Alternatively, you may use this file under the terms of the BSD license
** as follows:
**
** "Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions are
** met:
**   * Redistributions of source code must retain the above copyright
**     notice, this list of conditions and the following disclaimer.
**   * Redistributions in binary form must reproduce the above copyright
**     notice, this list of conditions and the following disclaimer in
**     the documentation and/or other materials provided with the
**     distribution.
**   * Neither the name of The Qt Company Ltd nor the names of its
**     contributors may be used to endorse or promote products derived
**     from this software without specific prior written permission.
**
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
** "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
** LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
** A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
** OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
** SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
** LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
** DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
** THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
** OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."
**
** $QT_END_LICENSE$
**
****************************************************************************/

import QtQuick 2.6
import QtQuick.Controls 2.1

import "qrc:/pages/"

Item {
    id: page
    width: 500
    height: 600

    Timer{
        id:mtimer
        interval: 100
        repeat: true
        onTriggered:
        {
            lEdit1.txtext = explc.readBool();
            lEdit2.txtext = explc.readByte();
            lEdit3.txtext = explc.readInt();
            listControl.arrlist = explc.readArray();
            var strJson = explc.readStruct();
            var jsonob = JSON.parse(strJson)
            var listjson = [jsonob.nData,jsonob.cByte]
            listControl1.arrlist = listjson;
            console.log(strJson);
        }
    }

    GroupBox {
        id: groupBox
        x: 8
        y: 24
        width: 205
        height: 553
        title: qsTr("Timer读数据")

        Button {
            id: button
            x: 0
            y: 408
            width: 99
            height: 50
            text: qsTr("开始读")
        }

        LEdit {
            lbText: qsTr("BOOL")
            id: lEdit1
            x: 0
            y: -14
        }

        LEdit {
            id: lEdit2
            x: 0
            y: 32
            lbText: qsTr("Byte")
        }

        LEdit {
            id: lEdit3
            x: 0
            y: 78
            lbText: qsTr("Int")
        }

        Label {
            id: label
            x: 0
            y: 148
            text: qsTr("Array:")
        }

        ListControl {
            id: listControl
            x: 20
            y: 119
            width: 179
            height: 192
        }

        Label {
            id: label1
            x: -12
            y: 308
            text: qsTr("Struct:")
        }

        ListControl {
            id: listControl1
            lines: 2
            x: 25
            y: 290
            width: 179
            height: 112
        }

        Button {
            id: button1
            x: 105
            y: 408
            width: 99
            height: 50
            text: qsTr("停止读")
        }
    }

    LEdit {
        id: lEdit5
        x: 226
        y: 86
        lbText: qsTr("Byte")
    }

    LEdit {
        id: lEdit4
        x: 226
        y: 40
        lbText: qsTr("BOOL")
    }

    LEdit {
        id: lEdit9
        x: 226
        y: 269
        lbText: qsTr("")
    }

    LEdit {
        id: lEdit8
        x: 226
        y: 231
        lbText: qsTr("")
    }

    LEdit {
        id: lEdit7
        x: 226
        y: 187
        lbText: qsTr("Array")
    }

    LEdit {
        id: lEdit6
        x: 226
        y: 134
        txtext: ""
        lbText: qsTr("Int")
    }

    LEdit {
        id: lEdit12
        x: 226
        y: 406
        lbText: qsTr("")
    }

    LEdit {
        id: lEdit11
        x: 226
        y: 359
        lbText: qsTr("Struct")
    }

    LEdit {
        id: lEdit10
        x: 226
        y: 314
        lbText: qsTr("")
    }

    Button {
        id: button2
        x: 232
        y: 466
        width: 113
        height: 50
        text: qsTr("写入")
    }


    Connections {
        target: button1
        onClicked:  mtimer.stop();
    }

    Connections {
        target: button
        onClicked:  mtimer.start();
    }

    Connections {
        target: button2
        onClicked: {
            explc.writeBool((Number(lEdit4.txtext) === 0)?false: true);
            explc.writeByte(Number(lEdit5.txtext));
            explc.writeInt(Number(lEdit6.txtext));
            var arry = [Number(lEdit7.txtext),Number(lEdit8.txtext),Number(lEdit9.txtext),Number(lEdit10.txtext)];
            explc.writeArray(arry);
            var struct = {"nData":Number(lEdit11.txtext),
            "cByte":Number(lEdit12.txtext)};
            explc.writeStruct(JSON.stringify(struct));
        }
    }






}
