/****************************************************************************
**
** Copyright (C) 2017 The Qt Company Ltd.
** Contact: https://www.qt.io/licensing/
**
** This file is part of the examples of the Qt Toolkit.
**
** $QT_BEGIN_LICENSE:BSD$
** Commercial License Usage
** Licensees holding valid commercial Qt licenses may use this file in
** accordance with the commercial license agreement provided with the
** Software or, alternatively, in accordance with the terms contained in
** a written agreement between you and The Qt Company. For licensing terms
** and conditions see https://www.qt.io/terms-conditions. For further
** information use the contact form at https://www.qt.io/contact-us.
**
** BSD License Usage
** Alternatively, you may use this file under the terms of the BSD license
** as follows:
**
** "Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions are
** met:
**   * Redistributions of source code must retain the above copyright
**     notice, this list of conditions and the following disclaimer.
**   * Redistributions in binary form must reproduce the above copyright
**     notice, this list of conditions and the following disclaimer in
**     the documentation and/or other materials provided with the
**     distribution.
**   * Neither the name of The Qt Company Ltd nor the names of its
**     contributors may be used to endorse or promote products derived
**     from this software without specific prior written permission.
**
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
** "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
** LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
** A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
** OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
** SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
** LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
** DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
** THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
** OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."
**
** $QT_END_LICENSE$
**
****************************************************************************/

import QtQuick 2.6
import QtCharts 2.0
import QtQuick.Layouts 1.0
import QtQuick.Controls 2.1

import "qrc:/pages/"

Item {
    id: page2
anchors.fill: parent
    property var datemax:new Date(2017,6,5, 14,36,0)
    property var datemin:new Date(2017,6,5 ,14,32,0)

    ChartView {
        id: chartView
        title: "Line"
        anchors.fill: parent
        antialiasing: true
        DateTimeAxis {
            id: xAxis
            format: "hh:mm:ss"
            tickCount: 4
            max:datemax
            min:datemin
        }
        ValueAxis {
            id:yAxis
            min: 0
            max: 100
        }

        LineSeries {
            id: series1;
            name:"曲线测试"
            axisX: xAxis;
            axisY: yAxis
        }

    }
    Component.onCompleted: {

       // resetCurveAxis()
        timeUpdate.start()
    }

    Timer
    {
        id:timeUpdate
        interval: 500;
        repeat: true;
        onTriggered:
        {
            xAxis.min = dataSource.getAxisMin()
            xAxis.max = dataSource.getAxisMax()
            yAxis.max = dataSource.getCurveYMax()
            {
                dataSource.update(series1,0);
            }
        }
    }

}
