#include "plcman.h"
#include<QString>
#include<QJsonObject>
#include<QJsonDocument>
#include <QVector>
#include <QDebug>

PlcMan::PlcMan(QObject *parent) : QObject(parent)
{

}

void PlcMan::setOption(SettingInterface* pSetting)
{  m_pSetting = pSetting;}

int PlcMan::testPlc()
{
    AdsPortCloseEx(port);
    readSetting();
    AdsAddRoute(m_ams.netId, m_strIP.toLatin1().data());
    port = AdsPortOpenEx();
    uint16_t adsState = 0; uint16_t devState = 0;
    AdsSyncReadStateReqEx(port,&m_ams,&adsState,&devState);
    return adsState;
}

void PlcMan::readSetting()
{
    m_ams.port = m_pSetting->getPort();
    QString strNetId = m_pSetting->getNetId();
    QStringList list;
    if ((list = strNetId.split(".")).length() == 6)
    {
           AmsNetId _AmsId = {list.at(0).toInt(), list.at(1).toInt(), list.at(2).toInt(),
                              list.at(3).toInt(), list.at(4).toInt(), list.at(5).toInt()};
           m_ams.netId = _AmsId;
    }
    m_strIP = m_pSetting->getIP();
//    if ((list = strIP.split(".")).length() == 4)
//    {
//           //char val[4] = {p1, p2, p3, p4};
//           remoteIpV4[0] = list.at(0).toInt();
//           remoteIpV4[1] = list.at(1).toInt();
//           remoteIpV4[2] = list.at(2).toInt();
//           remoteIpV4[3] = list.at(3).toInt();
//    }
}

QString PlcMan::init()
{
    AdsPortCloseEx(port);//
    //AmsNetId remoteNetId { 10, 41, 16, 7, 1, 1 };
    char remoteIpV4[] = "192.168.253.3";
    readSetting();//
    //AdsAddRoute(remoteNetId, remoteIpV4);
    AdsAddRoute(m_ams.netId, m_strIP.toLatin1().data());


    port = AdsPortOpenEx();

    int lErr = 0;
    {
        QString  strBool("Main.Data_Bool\0");
        lErr = AdsSyncReadWriteReqEx2(port,&m_ams, ADSIGRP_SYM_HNDBYNAME, 0x0, sizeof(m_hBool), &m_hBool,strBool.length(), strBool.toLatin1().data(),&bytesRead);
        QString strByte("Main.Data_Byte\0");
        lErr = AdsSyncReadWriteReqEx2(port,&m_ams, ADSIGRP_SYM_HNDBYNAME, 0x0, sizeof(m_hByte), &m_hByte, strByte.length(), strByte.toLatin1().data(),&bytesRead);
        QString strInt("Main.Data_Int\0");
        lErr = AdsSyncReadWriteReqEx2(port,&m_ams, ADSIGRP_SYM_HNDBYNAME, 0x0, sizeof(m_hInt), &m_hInt, strInt.length(), strInt.toLatin1().data(),&bytesRead);
        QString strArray("Main.Data_Array\0");
        lErr = AdsSyncReadWriteReqEx2(port,&m_ams, ADSIGRP_SYM_HNDBYNAME, 0x0, sizeof(m_hArray), &m_hArray, strArray.length(), strArray.toLatin1().data(),&bytesRead);
        QString strStruct("Main.Data_Struct\0");
        lErr = AdsSyncReadWriteReqEx2(port,&m_ams, ADSIGRP_SYM_HNDBYNAME, 0x0, sizeof(m_hStruct), &m_hStruct, strStruct.length(), strStruct.toLatin1().data(),&bytesRead);
    }
    QString strdata = QString("%1,%2,%3,%4,%5,%6").arg(m_ams.netId.b[0]).arg(m_ams.netId.b[1]).arg(m_ams.netId.b[2])
            .arg(m_ams.netId.b[3]).arg(m_ams.netId.b[4]).arg(m_ams.netId.b[5]);
    qDebug()<< strdata;
    return strdata;
}
bool PlcMan::readBool()
{
    bool bValue;
    AdsSyncReadReqEx2(port,&m_ams,
        ADSIGRP_SYM_VALBYHND,	//IndexGroup
        m_hBool,		//IndexOffset
        sizeof(bValue), //DataLength
        &bValue,&bytesRead);
    return bValue;
}
char PlcMan::readByte()
{
    char cValue;
    AdsSyncReadReqEx2(port,&m_ams,
        ADSIGRP_SYM_VALBYHND,	//IndexGroup
        m_hByte,		//IndexOffset
        sizeof(cValue), //DataLength
        &cValue,&bytesRead);
    return cValue;
}

qint16 PlcMan::readInt()
{
    short cValue = 0;
    AdsSyncReadReqEx2(port,&m_ams,
        ADSIGRP_SYM_VALBYHND,	//IndexGroup
        m_hInt,		//IndexOffset
        sizeof(cValue), //DataLength
        &cValue,&bytesRead);
    return cValue;
}

QVector<int> PlcMan::readArray()
{
    QVector<short> vecTemp;
    QVector<int> vecValue;
    vecTemp.resize(4);
    AdsSyncReadReqEx2(port,&m_ams,
        ADSIGRP_SYM_VALBYHND,	//IndexGroup
        m_hArray,		//IndexOffset
        sizeof(qint16) * 4, //DataLength
        &vecTemp[0],&bytesRead);

    for(int i = 0; i < vecTemp.count(); i++)
        vecValue.push_back(vecTemp[i]);
    return vecValue;
}

QByteArray PlcMan::readStruct()
{
    _AdsStruct adsob;
    AdsSyncReadReqEx2(port,&m_ams,
        ADSIGRP_SYM_VALBYHND,	//IndexGroup
        m_hStruct,		//IndexOffset
        sizeof(adsob) , //DataLength
        &adsob,&bytesRead);
    QJsonObject json;
    json["nData"] = adsob.nData;
    json["cByte"] = adsob.cByte;
    QJsonDocument doc(json);
    return doc.toJson();

}

void PlcMan::writeBool(bool bValue)
{
    AdsSyncWriteReqEx(port,&m_ams,
        ADSIGRP_SYM_VALBYHND,	//IndexGroup
        m_hBool,		//IndexOffset
        sizeof(bValue), //DataLength
        &bValue);
}

void PlcMan::writeByte(char cValue)
{
    AdsSyncWriteReqEx(port,&m_ams,
        ADSIGRP_SYM_VALBYHND,	//IndexGroup
        m_hByte,		//IndexOffset
        sizeof(cValue), //DataLength
        &cValue);
}

void PlcMan::writeInt(qint16 cValue)
{
    AdsSyncWriteReqEx(port,&m_ams,
        ADSIGRP_SYM_VALBYHND,	//IndexGroup
        m_hInt,		//IndexOffset
        sizeof(cValue), //DataLength
        &cValue);
}

void PlcMan::writeArray(QVector<int> nVec)
{
    QVector<short> vecValue;
    for(int i = 0; i < nVec.count(); i++)
        vecValue.push_back(nVec[i]);
    AdsSyncWriteReqEx(port,&m_ams,
        ADSIGRP_SYM_VALBYHND,	//IndexGroup
        m_hArray,		//IndexOffset
        sizeof(qint16) * 4, //DataLength
        &vecValue[0]);
}

void PlcMan::writeStruct(QByteArray str)
{
    QJsonDocument doc = QJsonDocument::fromJson(str);
    if(!doc.isNull())
    {
        QJsonObject json = doc.object();
        _AdsStruct adsob;
        adsob.nData = json["nData"].toInt();
        adsob.cByte = json["cByte"].toInt();
        AdsSyncWriteReqEx(port,&m_ams,
            ADSIGRP_SYM_VALBYHND,	//IndexGroup
            m_hStruct,		//IndexOffset
            sizeof(adsob) , //DataLength
            &adsob);
    }
}
