#ifndef PLCMAN_H
#define PLCMAN_H

#include <QObject>
#include "AdsLib/AdsDef.h"
#include "AdsLib/AdsLib.h"
#include "settinginterface.h"
class PlcMan : public QObject
{
    Q_OBJECT
public:
    explicit PlcMan(QObject *parent = nullptr);

    void setOption(SettingInterface* pSetting);

    Q_INVOKABLE int testPlc();
    Q_INVOKABLE QString init();

    void readSetting();

    struct _AdsStruct
    {
        qint16 nData;
        char cByte;
    };

protected:
    SettingInterface* m_pSetting;
    AmsAddr m_ams;
    char remoteIpV4[4];
    QString m_strIP;
    qint32 port;

    unsigned int m_hBool;
    unsigned int m_hByte;
    unsigned int m_hInt;
    unsigned int m_hArray;
    unsigned int m_hStruct;

    uint32_t bytesRead;
public slots:
    bool readBool();
    char readByte();
    qint16 readInt();
    QVector<int> readArray();
    QByteArray readStruct();

    void writeBool(bool bValue);
    void writeByte(char bValue);
    void writeInt(qint16 bInt);
    void writeArray(QVector<int> nVec);
    void writeStruct(QByteArray str);

};

#endif // PLCMAN_H
